#include <cstdio>
#include <vector>
#include <cstring>
#include <cstdlib>
#include <algorithm>

using namespace std;

#define FIN "nivele2.in"
#define FOUT "nivele2.out"

#define MAX_N 100010

int N, a, b, Dmax;

int use[MAX_N];

vector <int> G[MAX_N];
vector <int> level[MAX_N];

void error(char msg[], int p)
{
	fprintf(stderr, msg);
	printf("%d", p);
	exit(0);
}

void work(int nod, int depth) {
    use[nod] = 1;
    level[depth].push_back(nod);
    Dmax = max(Dmax, depth);

    for (vector <int>::iterator it = G[nod].begin(); it != G[nod].end(); ++it)
        if (use[*it] == 0)
            work(*it, depth + 1);
}

inline int get_number(int pos, char text[], int L) {
    int ans = 0;

    while ('0' <= text[pos] && text[pos] <= '9' && pos != L) {
        ans = ans * 10 + text[pos] - '0';
        text[pos++] = ' ';
    }

    return ans;
}

int main(void)
{
    FILE *f;

    f = fopen(FIN, "r");
    if (!f) error("Nu am putut deschide fisierul de intrare", 0);
    if (fscanf(f, "%d", &N) != 1)
        error("Eroare in fisierul de intrare", 0);
    else
        if (!(1 <= N && N <= 100000))
            error("Valoare incorecta pentru N", 0);

    for (int i = 1; i < N; i++)
    {
        if (fscanf(f, "%d %d", &a, &b) != 2)
            error("Eroare in fisierul de intrare", 0);
        else 
            if (!(1 <= a && a <= N && 1 <= b && b <= N && a != b))
                error("Muchie invalida", 0);
            else {
                G[a].push_back(b);
                G[b].push_back(a);
            }
    }

    work(1, 1);
    for (int i = 1; i <= Dmax; i++)
        sort(level[i].begin(), level[i].end());

    f = fopen(FOUT, "r");
    if (!f) error("Fisier de iesire inexistent", 0);

    char line[600000];
    char niv[] = "nivelul ";

    for (int lvl = 1; lvl <= Dmax; lvl++) {
        fgets(line, sizeof(line), f);

        for (int i = 0; i < 8; i++)
            if (niv[i] != line[i])
                error("Format de output incorect", 0);

        vector <int> A;

        int L = strlen(line), dp = 0;
        for (int i = 8; i < L; i++) {
            if (line[i] != ' ' && line[i] != ':' && line[i] != '\n' && !('0' <= line[i] && line[i] <= '9')) 
                error("Caractere invalide", 0);

            if (line[i] == ':')
                dp++;
    
            if ('0' <= line[i] && line[i] <= '9') {
                int k = get_number(i, line, L);

                if (i == 8) {
                    if (k != lvl)
                        error("Ai afisat nivelele intr-o ordine gresita", 0);
                }
                else
                    A.push_back(k);
            }

            if (i == 8) {
                for (int j = i; j < L; j++)
                    if ('0' <= line[j] && line[j] <= '9')
                        error("Format de afisare invalid", 0);
                    else
                        if (line[j] == ':')
                            break;
            }
        }

        if (dp != 1)
            error("Format de afisare invalid", 0);
       
        sort(A.begin(), A.end());

        if (A.size() != level[lvl].size()) {
            char err_msg[100];
            printf("%d %d %d\n", A.size(), level[lvl].size(), lvl);
            sprintf(err_msg, "Ai afisat gresit nodurile de pe nivelul %d", lvl);
            error(err_msg, 0);
        }

        L = A.size();
        for (int i = 0; i < L; i++)
            if (A[i] != level[lvl][i]) {
                char err_msg[100];
                sprintf(err_msg, "Ai afisat gresit nodurile de pe nivelul %d", lvl);
                error(err_msg, 0);
            }

        for (int i = 0; i < L; i++)
            line[i] = 0;
        vector <int> ().swap(A);
    }
    
    error("Raspuns corect!", 10);

    return 0;
}
